/*
 * Copyright (c) 2004-2005 The Trustees of Indiana University and Indiana
 *                         University Research and Technology
 *                         Corporation.  All rights reserved.
 * Copyright (c) 2004-2009 The University of Tennessee and The University
 *                         of Tennessee Research Foundation.  All rights
 *                         reserved.
 * Copyright (c) 2004-2005 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2004-2005 The Regents of the University of California.
 *                         All rights reserved.
 * Copyright (c) 2009      Cisco Systems, Inc.  All rights reserved.
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif  /* HAVE_UNISTD_H */
#ifdef HAVE_STRING_H
#include <string.h>
#endif  /* HAVE_STRING_H */
#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif  /* HAVE_SYS_TYPES_H */
#include <sys/mman.h>

#include "ompi_config.h"
#include "btl_srio_frag.h"


static inline void mca_btl_srio_frag_common_constructor(mca_btl_srio_frag_t* frag)
{
    frag->hdr = (mca_btl_srio_hdr_t*)frag->base.super.ptr;
    if(frag->hdr != NULL) {
        frag->hdr->frag = (mca_btl_srio_frag_t*)((uintptr_t)frag |
            MCA_BTL_SRIO_FRAG_ACK);
        frag->segment.seg_addr.pval = ((char*)frag->hdr) +
            sizeof(mca_btl_srio_hdr_t);
    }
    frag->segment.seg_len = frag->size;
    frag->base.des_src = &frag->segment;
    frag->base.des_src_cnt = 1;
    frag->base.des_dst = &frag->segment;
    frag->base.des_dst_cnt = 1;
    frag->base.des_flags = 0;
}

void mca_btl_srio_frag_init (mca_btl_srio_frag_t *frag, mca_btl_srio_t *srio_module)
{
#ifdef BTL_SRIO_VERBOSE
    opal_output_verbose (100, mca_btl_base_output, "BTL SRIO fragmentInitialized (btl=%p) frag=%p\n", srio_module, frag);
#endif
}

static void mca_btl_srio_frag1_constructor(mca_btl_srio_frag_t* frag)
{
    frag->size = mca_btl_srio_component.eager_limit;
    frag->my_list = &mca_btl_srio_component.srio_frags_eager;
    mca_btl_srio_frag_common_constructor(frag);
}

static void mca_btl_srio_frag2_constructor(mca_btl_srio_frag_t* frag)
{
    frag->size = mca_btl_srio_component.max_frag_size;
    frag->my_list = &mca_btl_srio_component.srio_frags_max;
    mca_btl_srio_frag_common_constructor(frag);
}

OBJ_CLASS_INSTANCE(
    mca_btl_srio_frag1_t,
    mca_btl_base_descriptor_t,
    mca_btl_srio_frag1_constructor,
    NULL);

OBJ_CLASS_INSTANCE(
    mca_btl_srio_frag2_t,
    mca_btl_base_descriptor_t,
    mca_btl_srio_frag2_constructor,
    NULL);

