#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <unistd.h>
#include <getopt.h>
#include "CJSON/cJSON.h"
#include "routingTableGen.h"
#include "mpi_interfaces.h"

int main(int argc, char *argv[])
{
	int cmd;
	int fd, res;
	char *topology_file_str = argv[1];
        int i,ret;
        FILE *topology_file=NULL;
       void *base=NULL;
       int cartridge_id  /*IN*/, node_id /*IN*/;
      unsigned short srioID,srioID1,srioID2,port;
//      int cartridge_phys_ids[]={1,2,3,4,5,6,7,8,9};
//      int cartridge_phys_ids[]={1,2,3,4,5,6,7};
//      int cartridge_phys_ids[]={1,4};
//      int cartridge_phys_ids[]={1,2,3,4,5,6};
      int cartridge_phys_ids[MAX_NUM_CARTRIDGES];
      int num_cartridge_phys_ids;
//      int cartridge_phys_ids[]={1,2,4,5};
//      int num_cartridge_phys_ids=sizeof(cartridge_phys_ids)/sizeof(int);
    
      

        if (argc <=2) {
 		perror("Insufficient arguments: Usage:  routingConfigGen <topology_file> <cartridge# > <cartridge# > <cartridge# > .. ");	
                 exit(-2);
        }
      
        num_cartridge_phys_ids=0;
       for(i=2;i<argc;i++) {
           sscanf(argv[i],"%d",&cartridge_phys_ids[num_cartridge_phys_ids]);
           num_cartridge_phys_ids++;
       }
      
        printf("\nCreating Routing structures");
        base = SrioRoutingStructuresCreate(topology_file_str);
        if(base==NULL) {
          printf("\nCreating Failed, returning...");
        }
        
       printf("\n Enabling Cartridges:  ");
       for(i=0;i<num_cartridge_phys_ids;i++) {
          printf("\n c%d",cartridge_phys_ids[i]);
       }
      printf("\n");
      ret=SrioCreateRoutingTableFromCluster(base,cartridge_phys_ids,num_cartridge_phys_ids);
      if(ret!=0) {
           printf("\n Routing Table creation failed!!");
     } 

     ret=SrioDisplayClusterInformation(base);
   
    // printf("\nPress any key to continue..");
     //getchar();
     // printf("\nResetting Cluster ");
     //ret=SrioResetCluster(base);
     //printf("\nPress any key to continue..");
     //getchar();
       printf("\n Enabling Cartridges:  ");
       for(i=0;i<num_cartridge_phys_ids;i++) {
          printf("\n c%d",cartridge_phys_ids[i]);
       }
      printf("\n");
      ret=SrioCreateRoutingTableFromCluster(base,cartridge_phys_ids,num_cartridge_phys_ids);

     //ret=SrioDisplayClusterInformation(base);
     //ret=SrioCreateRoutingTableFromCluster(base,cartridge_phys_ids,num_cartridge_phys_ids);
      ret=SrioDisplayClusterInformation(base);
      simulate_cluster_paths(base);
     
#if 0
        /* Test SRIO Test Table */
        printf("\n Testing Cartridge ID --> PhysID ");
         for(cartridge_id=1;cartridge_id<=7;cartridge_id+=3) { 
             for(node_id=1;node_id<=4;node_id++) {   
                 ret=SrioGetSrioIDFromPhysID(base, cartridge_id,node_id,&srioID);
                 printf("\n SRIO ID (C%d,N%d) = %d",cartridge_id,node_id,srioID);
             } 
        }

        /* Test Routing Table */
        printf("\n Test SRIO ID --> Phys ID ");
        for(srioID=1;srioID<=12;srioID++) {   
            ret=SrioGetPhysIDFromSRIOID(base, srioID,&cartridge_id,&node_id);
            printf("\n SRIOID#%d= C%d,N%d",srioID,cartridge_id,node_id,srioID);
        } 
         printf("\n");


        /* Test Connection Matrix Table */
        printf("\n Testing Connction Matrix...");
         for(srioID1=1;srioID1<=12;srioID1++) { 
             for(srioID2=1;srioID2<=12;srioID2++) { 
                port=SrioGetRoutingPort(base, srioID1,srioID2);
                printf("\n SRIO ID %d is connected to SRIO ID %d, through port %d",srioID1,srioID2,port);  
           } 
        }


#endif

       /* Reading From the file now */

	exit(0);
}
