#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <unistd.h>
#include <getopt.h>
#include "CJSON/cJSON.h"
#include "routingTableGen.h"


int main(int argc, char *argv[])
{
	char *topology_json_file_str = argv[1];
	char *topology_output_file_str = argv[2];
        FILE *json_file=NULL,*topology_file;
        void *base=NULL;
        DepthToCartridge_t DepthToCartridges[MAX_NUM_CARTRIDGES][MAX_NUM_CARTRIDGES];
       Topology_t  topology_unordered;
       Topology_t  topology_ordered; /* Ordered as X,Y , Row Major */
       if(argc!=3) {
         printf("\n Usage: topology_parse <jsonfile> <outputfile> \n");
         return -1;
        } 
	if((topology_file = fopen(topology_output_file_str,"wb"))==NULL) {
            printf("\n Cannot open output table for toplogy ");

       }
        cjson_topology_parse(topology_json_file_str,&topology_unordered);
        //printf("after topology_parse \n");
        //print_topology(&topology_unordered);
        //getchar();
        topology_assign_xy(&topology_unordered, &moonshotXY);
        //printf("after assign_xy \n");
        //print_topology(&topology_unordered);
        //getchar();
        topology_sort (&topology_unordered, &topology_ordered);
        //printf("after topology_sort \n");
        //print_topology(&topology_ordered);
        //getchar();
        printf("\n Establishing connection ..");
        topology_establish_connection (&topology_ordered);
        //printf("after topology_establish_connection \n");
        print_topology_connected(&topology_ordered); 

        printf("\n Writing topology to the bin file %s ...\n",topology_output_file_str);
        fwrite(&topology_ordered,sizeof(topology_ordered),1,topology_file); 
          
	exit(0);
}

